/**************************************************************************
**       Title: ConnectedComponentLabeling
**    $RCSfile: ConnectedComponentLabeling.cc,v $
**   $Revision: 1.4 $$Name:  $
**       $Date: 2005/05/02 11:25:37 $
**   Copyright: GPL $Author: fehr $
** Description:
**
**                      
**                  
**-------------------------------------------------------------------------
**              
**  $Log: ConnectedComponentLabeling.cc,v $
**              
**                  
**************************************************************************/

#include "ConnectedComponentLabeling.hh"


int ConnectedComponentLabeling::getNumberOfObjects()
{
    return NumberOfObjects;
}

void ConnectedComponentLabeling::label(IntImage& image)
{
    int ObjectNumber = 2;  //start labeling at 2
    std::queue<int> ToDo; 
    //run over image
    for (int i = 0; i<image.size();i++)
    {
	if (image[i] == 1) //object found
	{
	    _todo.push(i);
	    image[i] = ObjectNumber;
	    while(!_todo.empty())//run through neighbourhood
	    {
		if( (_todo.front()+1<image.size()) &&(image[(_todo.front()+1)] == 1)) 
		{   
		    _todo.push(_todo.front()+1);
		    image[_todo.front()+1] = ObjectNumber;
		}//right
		if( (_todo.front()-1>=0)&&(image[_todo.front()-1] == 1)) 
		{
		    _todo.push(_todo.front()-1);
		    image[_todo.front()-1] = ObjectNumber;
		}//left
		if( ((_todo.front()+image.width())<image.size())&&(image[_todo.front()+image.width()] == 1)) 
		{
		    _todo.push(_todo.front()+image.width());
		    image[_todo.front()+image.width()] = ObjectNumber;
		}//down
		if( ((_todo.front()-image.width())>=0)&&(image[_todo.front()-image.width()] == 1)) 
		{
		    _todo.push(_todo.front()-image.width());
		    image[_todo.front()-image.width()] = ObjectNumber;
		}//top
		
		_todo.pop();
	    }
	    ObjectNumber++;
	}

    }
    
    NumberOfObjects = ObjectNumber - 2;

}
