/**************************************************************************
**       Title: int image
**    $RCSfile: IntImage.cc,v $
**   $Revision: 1.7 $$Name:  $
**       $Date: 2005/05/02 09:27:57 $
**   Copyright: GPL $Author: fehr $
** Description:
**
**    
**
**-------------------------------------------------------------------------
**
**  $Log: IntImage.cc,v $
**
**
**************************************************************************/

#include "IntImage.hh"

#include <iomanip>
#include <iostream>
#include <string>
#include <cctype>

/*=========================================================================
 *  DESCRIPTION OF FUNCTION:  Default Constructor
 *  ==> see headerfile
 *=======================================================================*/
IntImage::
IntImage()
        :_width(0), _height(0), _size(0),
         _pixels(0), _pixelsEnd(0),
         _rowStart(0)
{}

/*=========================================================================
 *  DESCRIPTION OF FUNCTION:  Copy Constructor
 *  ==> see headerfile
 *=======================================================================*/
IntImage::
IntImage(const IntImage& image)
        :_width(0), _height(0), _size(0),
         _pixels(0), _pixelsEnd(0),
         _rowStart(0)
{
  (*this)=image;
}

/*=========================================================================
 *  DESCRIPTION OF FUNCTION:  Size Constructor
 *  ==> see headerfile
 *=======================================================================*/
IntImage::
IntImage(unsigned int width, unsigned int height)
        :_width(0), _height(0), _size(0),
         _pixels(0), _pixelsEnd(0),
         _rowStart(0)
{
  resize(width, height);
}



/*=========================================================================
 *  DESCRIPTION OF FUNCTION:  Destructor
 *  ==> see headerfile
 *=======================================================================*/
IntImage::
~IntImage()
{
  delete[] _pixels;
  delete[] _rowStart;
}

/*=========================================================================
 *  DESCRIPTION OF FUNCTION:  resize(...)
 *  ==> see headerfile
 *=======================================================================*/
void 
IntImage::
resize(unsigned int width, unsigned int height)
{
  if (width>MAX_DIMENSION || height>MAX_DIMENSION)
  {
    MyError e("Desired dimensions are too large");
    throw e;
  }

  if (width==0 || height==0)
  {
    width=0;
    height=0;
  }
  
  if (width!=_width || height!=_height)
  {
    unsigned int newSize=width*height;
    _width=width;
    
    if (_size!=newSize)
    {
      delete[] _pixels;
      _pixels=new int[newSize];
      if (!_pixels)
      {
        MyError e("Not enough memory available to store image");
        throw e;
      }
      
      _pixelsEnd=_pixels+newSize;
      _size=newSize;
    }

    if (_height!=height)
    {
      delete[] _rowStart;
      _rowStart=new int*[height];
      if (!_rowStart)
      {
        MyError e("Not enough memory available to store image");
        throw e;
      }

      _height=height;
    }

    int* itPixel=_pixels;
    for (unsigned int i=0; i<_height; ++i)
    {
      _rowStart[i]=itPixel;
      itPixel+=_width;
    }   
  }
}

/*=========================================================================
 *  DESCRIPTION OF FUNCTION:  operator=(...)
 *  ==> see headerfile
 *=======================================================================*/
IntImage& 
IntImage::
operator=(const IntImage& image)
{
  if (this != (&image))
  {
    resize(image.width(), image.height());
    
    const int* p1=image.begin();
    int* p2=begin();
    
    while (p1!=image.end())
    {
      *p2=*p1;
      ++p1;
      ++p2;
    }
    
  }
  
  return *this;
}
