/**************************************************************************
**       Title: Base class for all error classes
**    $RCSfile: MyError.hh,v $
**   $Revision: 1.1 $$Name:  $
**       $Date: 2002/10/24 10:11:43 $
**   Copyright: IIF-LMB $Author: pigorsch $
** Description:
**
**    
**
**-------------------------------------------------------------------------
**
**  $Log: MyError.hh,v $
**  Revision 1.1  2002/10/24 10:11:43  pigorsch
**  *** empty log message ***
**
**  Revision 1.1  2001/04/03 18:44:00  haasdonk
**  second version without STL-components
**
**  Revision 1.2  2001/04/03 15:20:13  haasdonk
**  removed STL-commands and typedefs
**
**  Revision 1.1  2001/04/01 12:11:48  ronneber
**  initial revision
**
**
**************************************************************************/

#ifndef MY_ERROR_HH
#define MY_ERROR_HH

#include <string>

/*======================================================================*/
/*!
 *  \class MyError MyError.hh
 *  \brief The MyError class is the base class for all errors in this
 *  library.
 *
 *  The inherited classes are used for throwing, so that the library
 *  user can do a simple catch( MyError err) to catch all errors.
 */
/*======================================================================*/
class MyError
{
public: 
  /*======================================================================*/
  /*! 
   *   Constructor taking a plain text error message
   *
   *   \param s  plain text error message
   */
  /*======================================================================*/
  MyError(std::string s)
          :_message(s)
        {
          // nothing to do here
        }

  /*======================================================================*/
  /*! 
   *   return the plain text error message, that was passed to the
   *   constructor  
   *
   *   \return plain text error message
   */
  /*======================================================================*/
  const std::string& msg() const
        {
          return _message;
        }
  

private:  
  std::string _message; 
};

#endif

