/**************************************************************************
**       Title: RGBClassifier
**    $RCSfile: RGBClassifier.hh,v $
**   $Revision: 1.4 $$Name:  $
**       $Date: 2005/05/02 11:25:37 $
**   Copyright: GPL $Author: fehr $
** Description:
**
**    
**
**-------------------------------------------------------------------------
**
**  $Log: RGBClassifier.hh,v $
**
**
**************************************************************************/

#ifndef RGB_CLASSIFIER
#define RGB_CLASSIFIER

#include "RGBColor.hh"
#include "SimpleRGBImage.hh"
#include "IntImage.hh"

/*======================================================================*/
/*!
 *  \class RGBClassifier
 *  \brief The RGBClassifier class returns a binary IntImage with separated 
 * for- and background.
 *
 */
/*======================================================================*/
class RGBClassifier
{
    public:
  /*======================================================================*/
  /*! 
   *   Default Constructor. 
   */
  /*======================================================================*/
	RGBClassifier(){};

  /*======================================================================*/
  /*! 
   *   Constructor setting tolerance and color
   */
  /*======================================================================*/
	RGBClassifier(const RGBColor& color, int r, int g, int b);

  /*======================================================================*/
  /*! 
   *   Destructor 
   */
  /*======================================================================*/
	~RGBClassifier(){};
    
  /*======================================================================*/
  /*! 
   *   set tolerance of forground color
   *   \param r 	red channel tolerance
   *   \param g  	green channel tolerance
   *   \param b         blue channel tolerance
   */
  /*======================================================================*/
	void setTolerance(int r, int g, int b);
	
  /*======================================================================*/
  /*! 
   *   sets color of Objects
   *   \param color 	Oject RGBColor color 
   */
  /*======================================================================*/
	void setObjektColor(const RGBColor& color);

  /*======================================================================*/
  /*!   
   *   group all pixels of in to Object =1 or background =0
   *   \param in     SimpleRGBImage input
   *   \return       pointer to binary IntImage  
   */
  /*======================================================================*/
	IntImage* classify(const SimpleRGBImage& in);

    private:
	int tolerance_r;
	int tolerance_g;
	int tolerance_b;
	RGBColor ObjectColor;

};

#endif
