/**************************************************************************
**       Title: RGB Color class
**    $RCSfile: RGBColor.cc,v $
**   $Revision: 1.1 $$Name:  $
**       $Date: 2002/10/30 13:18:26 $
**   Copyright: GPL $Author: pigorsch $
** Description:
**
**    
**
**-------------------------------------------------------------------------
**
**  $Log: RGBColor.cc,v $
**  Revision 1.1  2002/10/30 13:18:26  pigorsch
**  - initial revision
**
**
**
**************************************************************************/

#include <iostream>
#include <iomanip>
#include "RGBColor.hh"

const RGBColor RGBColor::White   = RGBColor( 255, 255, 255);
const RGBColor RGBColor::Red     = RGBColor( 255,   0,   0);
const RGBColor RGBColor::Green   = RGBColor(   0, 255,   0);
const RGBColor RGBColor::Blue    = RGBColor(   0,   0, 255);
const RGBColor RGBColor::Black   = RGBColor(   0,   0,   0);
const RGBColor RGBColor::Yellow  = RGBColor( 255, 255,   0);
const RGBColor RGBColor::Magenta = RGBColor( 255,   0, 255);
const RGBColor RGBColor::Cyan    = RGBColor(   0, 255, 255);

/*=========================================================================
 *  DESCRIPTION OF FUNCTION:  Default Constructor
 *  ==> see headerfile
 *=======================================================================*/
RGBColor::RGBColor () 
        : rc(0), gc(0), bc(0)
{
}

/*=========================================================================
 *  DESCRIPTION OF FUNCTION:  Constructor for arbitrary color
 *  ==> see headerfile
 *=======================================================================*/
RGBColor::RGBColor (uchar red, uchar green, uchar blue) 
        : rc(red), gc(green), bc(blue) 
{
}

/*=========================================================================
 *  DESCRIPTION OF FUNCTION:  Constructor for gray
 *  ==> see headerfile
 *=======================================================================*/
RGBColor::RGBColor (uchar gray) 
        : rc(gray), gc(gray), bc(gray) 
{
}

/*=========================================================================
 *  DESCRIPTION OF FUNCTION:  print()
 *  ==> see headerfile
 *=======================================================================*/
void RGBColor::print() const
{
  std::cout << "("  << std::setw(3) << int(rc)
            << ", " << std::setw(3) << int(gc)
            << ", " << std::setw(3) << int(bc) << ")";
  
}
